# eSM for CpML schemas

This file describes the change history of the eSM for CpML schemas.


# Version 2.0
- initial schema version

## Version 2.0.1
- Description of OtherAdressDetails added.

## Version 2.0.2
- Values for repeated fields in AggregationKeys must be unique.
- LineItem/Description is optional.
- LineItem/TransactionType is optional.
- Pattern for SSDSIDType corrected.

## Version 2.0.3
- InvoiceData > InvoiceID and InvoiceDate are optional (business rules added in spec)

## Version 2.0.4
- Error fixed: SupplierTradeID is optional
- VATIDType: Pattern extended, for example, for Swiss IDs.
- SSDSIDType: Pattern extended to integrate changes to VATIDType.
- IBANType: Pattern extended, for example, for Dutch, Romanian or UK IBANs.
- PurchaseOrderNumber renamed to PurchseOrSalesOrderNumber

## Version 2.0.5
- StreetNumber is otional.
- RegulatoryWording is optional.

## Version 2.0.6
- Added schemas for eSM process messages.
- Error fixed: PurchaseSalesOrderNumber field removed.
- Add value "FixedAndFloating" to 'FixedOrFloating'.
- Define all prices or price-related fields as unsigned values. New type "UnsignedPriceType" added.
- Define all quantities other than prices as unsigned values. New type "UnsignedQuantityType" added.

## Version 2.0.7
- no schema changes, only explanation added to spec

## Version 2.0.8
- 'AgreementType' changed to 'ESMAgreementType' to extend the field from 35 to 110 characters

## Version 3.0
- 'PaymentDate' added to 'AggregationKeys' and removed from 'InvoiceData' and 'NettingStatement'
- "Fee" and "UKA" added to units of measurement, new type = 'ESMUnitOfMeasurementType'
- 'PhysicalOrFinancial' removed from 'LineItem'
- New values for 'PhysicalOrFinancialType':  "PhysicalFeeOrPremium" and "FinancialFeeOrPremium"
- Fee types added to 'TransactionType', new type = 'ESMTransactionType'
- Values of 'LineItemsMatchingType' changed to "Strict" and "NonStrict"
- 'DeliveryPointOrZone' and 'MarketInformation' removed from 'LineItemDetails'
- Simple types sorted alphabetically in ESM-ElementsAndTypes.xsd

## Version 3.1
- Bux fix: missing value 'PHYS_FEE' added to 'ESMTransactionType'.
- Type of field 'VATRate' changed to new type "DecimalPercentageType", which requires to enter a percentage as a decimal value.
- 'VATRate' removed from line item details for invoices.

## Version 3.2
- Optional field 'BranchInformation'  added in 'InvoiceData/Customer' section and 'NettingStatement/Customer' section.
- Undo non-backward-compatible change from 3.1: 'VATRate' re-added to line item details for invoices. All
  'VATRate' fields use the type "UnsignedPriceType" again instead of "DecimalPercentageType".

## Version 3.3
- No changes to schema, changes to eSM standard only.

## Version 3.4
- For financial invoices, allow signed values in line items and line item details so that multiple transactions
  can be grouped in one line item.
- For field 'NatureOfPrice', add additional value 'NotApplicable'.
- For field 'MarketInformation', add additional value "ALL".
- Bug fix: Type "AlphanumericType" was accidentally removed from field 'NettingStatement/Supplier/BranchInformation' in V3.2.
  This has been fixed.
  
## Version 3.5
- Add additional values to field 'Commodity':  "EUAPhase_4", "ERU", "AAU", "UKA"

## Version 3.6
- Field 'InvoiceData\TotalVolume' is now optional (business rule makes it conditional, to be omitted for financials)
- 'ESMEnergyProductType': value "GoO" (Guarantee of Origin) added.
- Invoices > 'LineItems/LineItem': new section 'GoODetails' with fields 'RegionOfOrigin', 'Technology', 'VintagePeriodStartDate' and 'VintagePeriodEndDate'. 
- 'NettingStatement/Supplier': fields 'CompanyRegistryNumber', 'CompanyRegistryName', 'CompanyRegistryCity', and 'CompanyRegistryCountry' 
  made optional (business rules make the fields conditional, mandatory for document issuer).   
